clear
format("v",10)

tic()

// Glycerol - Acetone - Water - Solketal- Ethanol

RQ_k(1,1) = 0.6744;	RQ_k(1,2) = 0.54;
RQ_k(2,1) = 0.4469;	RQ_k(2,2) = 0.228;
RQ_k(3,1) = 1;      RQ_k(3,2) = 1.2;
RQ_k(4,1) = 0.9011;	RQ_k(4,2) = 0.848;
RQ_k(5,1) = 1.6724;	RQ_k(5,2) = 1.448;
RQ_k(6,1) = 0.92;	RQ_k(6,2) = 1.4;
RQ_k(7,1) = 0.2195;	RQ_k(7,2) = 0;
RQ_k(8,1) = 0.6908;	RQ_k(8,2) = 0.468;
RQ_k(9,1) = 0.9183;	RQ_k(9,2) = 0.78;
 
R=RQ_k(:,1)'
Q=RQ_k(:,2)'

// Gly  Ac  W Solk  Eth
Ci=[2 0 0 1 1
    1 0 0 0 0
    3 0 0 1 1
    0 1 0 2 1
    0 1 0 0 0
    0 0 1 0 0
    0 0 0 1 0
    0 0 0 1 0
    0 0 0 1 0];

C=Ci'

x=[ 1e-6 0.5 1e-6 1e-6 0.5];
T=298;
 

a_nm(1,1) = 0;     a_nm(1,2) = 0;     a_nm(1,3) = 986.5;	a_nm(1,4) = 0;         a_nm(1,5) = 476.4;	a_nm(1,6) = 1318;	a_nm(1,7) = 0;         a_nm(1,8) = 251.5;	a_nm(1,9) = 251.5;
a_nm(2,1) = 0;     a_nm(2,2) = 0;     a_nm(2,3) = 986.5;	a_nm(2,4) = 0;         a_nm(2,5) = 476.4;	a_nm(2,6) = 1318;	a_nm(2,7) = 0;         a_nm(2,8) = 251.5;	a_nm(2,9) = 251.5;
a_nm(3,1) = 156.4; a_nm(3,2) = 156.4; a_nm(3,3) = 0;         a_nm(3,4) = 156.4;     a_nm(3,5) = 84;	a_nm(3,6) = 353.5;	a_nm(3,7) = 156.4;	a_nm(3,8) = 28.06;	a_nm(3,9) = 28.06;
a_nm(4,1) = 0;     a_nm(4,2) = 0;     a_nm(4,3) = 986.5;	a_nm(4,4) = 0;         a_nm(4,5) = 476.4;	a_nm(4,6) = 1318;	a_nm(4,7) = 0;         a_nm(4,8) = 251.5;	a_nm(4,9) = 251.5;
a_nm(5,1) = 26.76; a_nm(5,2) = 26.76; a_nm(5,3) = 164.5;	a_nm(5,4) = 26.76;	a_nm(5,5) = 0;         a_nm(5,6) = 472.5;	a_nm(5,7) = 26.76;	a_nm(5,8) = -103.6;	a_nm(5,9) = -103.6;
a_nm(6,1) = 300;   a_nm(6,2) = 300;   a_nm(6,3) = -229.1;	a_nm(6,4) = 300;	a_nm(6,5) = -195.4;	a_nm(6,6) = 0;         a_nm(6,7) = 300;	a_nm(6,8) = 540.5;	a_nm(6,9) = 540.5;
a_nm(7,1) = 0;     a_nm(7,2) = 0;     a_nm(7,3) = 986.5;	a_nm(7,4) = 0;         a_nm(7,5) = 476.4;	a_nm(7,6) = 1318;	a_nm(7,7) = 0;         a_nm(7,8) = 251.5;	a_nm(7,9) = 251.5;
a_nm(8,1) = 83.36; a_nm(8,2) = 83.36; a_nm(8,3) = 237.7;	a_nm(8,4) = 83.36;	a_nm(8,5) = 191.1;	a_nm(8,6) = -314.7;	a_nm(8,7) = 83.36;	a_nm(8,8) = 0;         a_nm(8,9) = 0;
a_nm(9,1) = 83.36; a_nm(9,2) = 83.36; a_nm(9,3) = 237.7;	a_nm(9,4) = 83.36;	a_nm(9,5) = 191.1;	a_nm(9,6) = -314.7;	a_nm(9,7) = 83.36;	a_nm(9,8) = 0;         a_nm(9,9) = 0;

anm=a_nm


function u=UNIFAC(R,Q,C,x,Treactor,anm)
format("v",10)
s=size (C);
r=zeros(1,s(1));
q=zeros(1,s(1));
V=zeros(1,s(1));
F=zeros(1,s(1));
X=zeros(1,s(2));
//r and q calculation
for j=1:s(1)  // s(1)=2
   r(j)=C(j,:)*R'; 
   q(j)=C(j,:)*Q';
end  
//V and F calculation
for j=1:s(1)
    V(j)=r(j)/(x*r');  
//    Vl(j)=(r(j))^(3/4)/(x*(r.^(3/4))');  
    F(j)=q(j)/(x*q'); 
 
//    lnGammaC(j)=1-V(j)+log (V(j))-5*q(j)*(1-V(j)/F(j)+log (V(j)/F(j)));         //Calculation of combinatorial part
lnGammaC(j)= 1-V(j)+log(V(j))-5*q(j)*(1-V(j)/F(j)+log(V(j)/F(j)))
end

//PSI caculation, all the values are devided by the temperature (T), for the
//diagonal values PSI=1;
PSI=exp(-(anm)/Treactor);

// X calculation (for groups)
for j=1:s(1)
    ngroups(j)=sum(C(j,:));
    CALC1(j)=ngroups(j)*x(j);//This i just a middle calculator for the calculation of X
end
CALC2=sum(CALC1);
for j=1:s(2)
    CALC3(j)=x*C(:,j);
end
Xgroups=CALC3/CALC2;
//teta for groups
for j=1:s(2)
    teta(j)=Xgroups(j)*Q(j)/sum(Xgroups.*Q');
end
//middle calculation for group Gamma calculations
for j=1:s(2) 
    CALC4(j,:)=teta.*PSI(j,:)';
end
for j=1:s(2) 
    CALC5(j,:)=teta.*PSI(:,j);
end
for i=1:s(2)
    for j=1:s(2)
        CALC6(j)=CALC4(i,j)/sum(CALC5(j,:));
    end
    lnY(i)=Q(i)*(1-log(teta'*PSI(:,i))-sum(CALC6)); //Group activity coefficients for the binary system
end

//Xpure calculation
for i=1:s(1)
    for j=1:s(2)
        Xpure(i,j)=C(i,j)/sum(C(i,:));
        
    end
end

//Teta pure calculation
for i=1:s(1)
    for j=1:s(2)
      
        CALC7(i,j)=Q(j)*Xpure(i,j); 
        
    end
    tetapure(i,:)=CALC7(i,:)./sum(CALC7(i,:)); //in this case teta pure is different for each component, while it was similar for the previous case   
end

//middle calculation for pure Gamma calculations
for i=1:s(1)    
    for j=1:s(2)  
        CALC8(j)=tetapure(i,:)*PSI(:,j); //this is for calculation of "denominator" part
        CALC9(j,:)=tetapure(i,:).*PSI(j,:);//this is for calculation of "numerator" part
    end
    for j=1:s(2)
        CALC10(i,j)=sum(CALC9(j,:)./CALC8');
        CALC11(i,j)=log(sum(tetapure(i,:).*PSI(:,j)'));
    end

    
    for j=1:s(2)
        
        lnYpure(i,j)=Q(j)*(1-CALC11(i,j)-CALC10(i,j));
    end
    
        //disp(lnYpure) //erro tabela 27:20
end
for j=2:s(1)    
    lnY(j,:)=lnY(1,:);
end

for i=1:s(1)
for j=1:s(2)
CALCl2(i,j)=C(i,j).*(lnY(j)-lnYpure(i,j));
end
end

for j=1:s(1)
    lnGammaR(j)=sum(CALCl2(j,:));
end

lnGamma=lnGammaR+lnGammaC;
u=exp(lnGamma);
endfunction

activity=UNIFAC(R,Q,C,x,T,anm)

disp(activity)

tempo_decorrido = toc();
disp('Tempo decorrido na simulação: ' + string(tempo_decorrido/60) + ' minutos');
