// Example with Scilab code
//--------------------------------------------------
function [dCdt, ires]=chemres(t, y, yd)
    dC1dt = -0.04*y(1) + 1d4*y(2)*y(3) - yd(1);
    dC2dt =  0.04*y(1) - 1d4*y(2)*y(3) - 3d7*y(2)*y(2) - yd(2);
    dC3dt =       y(1) +     y(2)      + y(3)-1;
    ires =  0;
    
    dCdt=[dC1dt; dC2dt; dC3dt]
    
endfunction



x0 = [1; 0; 0];
xd0 = [-0.04; 0.04; 0];
t = [1:1:50];

y = dassl([x0, xd0], 0, t, chemres)'; // Returns requested observation time points
